unit Unit1;

{
  bitmap expansion project
  control unit
  2-12-2020
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, dav7components, jpeg;

type
  TForm1 = class(TForm)
    PaintBox2: TPaintBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    PaintBox1: TPaintBox;
    BitBtn3: TBitBtn;
    msglabel: TLabel;
    Hscrollbar: TScrollBar;
    Vscrollbar: TScrollBar;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    xtimer: Tdav7Timer;
    timelabel: TStaticText;
    Label1: TLabel;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormPaint(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure VscrollbarChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  map1,map2 : TBitmap;
  imageloaded : boolean;

implementation

{$R *.dfm}

uses expansion_unit;

procedure paintedges(box : TPaintbox);
var x1,y1,x2,y2 : word;
    i : byte;
begin
 with box do
  begin
   x1 := left-2;
   y1 := top-2;
   x2 := left+width+1;
   y2 := top + height+1;
  end;
 with form1.Canvas do
  begin
   pen.width := 1;
   pen.Color := 0;
   for i := 0 to 1 do
    begin
     moveto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
     lineto(x1+i,y1+i);
    end;
  end;
end;

procedure clearbox(box : TPaintbox);
begin
 with box do with canvas do
  begin
   brush.color := $ffffff;
   brush.style := bsSolid;
   fillrect(rect(0,0,width,height));
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 paintedges(paintbox1);
 paintedges(paintbox2);
end;

procedure createmap1;
begin
 map1 := TBitmap.Create;
 with map1 do
  begin
   width := 400;
   height := 400;
   pixelformat := pf32bit;
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
//load bmp or jpg
var s : string;
    jPegImage : TjPegImage;
begin
 msglabel.Caption := '';
 with opendialog1 do
  if execute then
   begin
    if assigned(map1) = false then createmap1;
    ImageLoaded := false;
    s := lowercase(extractFileExt(filename));
    if s = '.jpg' then                        //jpg file
     begin
      jpegImage := TJpegImage.Create;
      JpegImage.LoadFromFile(filename);
      map1.Width := jpegimage.Width;
      map1.Height := jpegimage.Height;
      map1.Canvas.Draw(0,0,jpegimage);
      ImageLoaded := true;
      jpegimage.Free;
     end;
    if s = '.bmp' then
     begin                                    //bmp file
      map1.loadfromfile(filename);
      ImageLoaded := true;
     end;
    if ImageLoaded then
     begin
      map1.pixelformat := pf32bit;
      msglabel.Caption := 'loaded: '+extractfilename(filename);
      clearbox(paintbox1);
      paintbox1.canvas.draw(0,0,map1);
      statictext1.caption := inttostr(map1.width);
      statictext2.Caption := inttostr(map1.height);
     end;
   end;//execute
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
//expand bm1 to bm2
var mtplr : byte;
    d : smallint;
begin
 if imageloaded = false then
  begin
   msglabel.caption := 'no image loaded';
   exit;
  end;
 if speedbutton1.Down then mtplr := 2 else mtplr := 3;
 if assigned(map2) = false then
  with map2 do
   begin
    map2 := TBitmap.Create;
    map2.PixelFormat := pf32bit;
   end;
 map2.Width := mtplr*map1.Width;
 map2.Height := mtplr*map1.Height;
 clearbox(paintbox2);
 xtimer.start;
 case mtplr of
  2 : begin
       X2copy(map2,map1);
      end;
  3 : begin
       X3copy(map2,map1);
      end; 
 end;
 xtimer.stop;
 d := map2.width - paintbox2.Width;
 if d < 0 then d := 0;
 Hscrollbar.max := d;
 Hscrollbar.position := 0;
 d := map2.Height - paintbox2.Height;
 if d < 0 then d := 0;
 Vscrollbar.Max := d;
 Vscrollbar.position := 0;
 timelabel.caption := xtimer.ElapsedTimeString;
 paintbox2.Canvas.Draw(0,0,map2);
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
//clear paintbox1
begin
 clearbox(paintbox1);
 imageloaded := false;
 msglabel.caption := '';
 statictext1.caption := '';
 statictext2.Caption := '';
 timelabel.Caption := '';
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
//clear paintbox2
begin
 clearbox(paintbox2);
 timelabel.Caption := '';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 if assigned(map1) then map1.Free;
 if assigned(map2) then map2.free;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
//store map2
begin
 with savedialog1 do
  if execute then
   begin
    map2.SaveToFile(filename);
    msglabel.Caption := 'saved: '+extractfilename(filename);
   end;
end;

procedure TForm1.VscrollbarChange(Sender: TObject);
//V,H scrollbar changes
//repaint paintbox2
var BW,BH : word;//paintbox width,height
    rs,rd : Trect; //source,destination rect
begin
 BW := paintbox2.Width;
 BH := paintbox2.Height;
 with rs do
  begin
   left := Hscrollbar.position;
   top := Vscrollbar.position;
   right := left + BW;
   bottom := top + BH;
  end;
 with rd do
  begin
   left := 0;
   top := 0;
   right := BW;
   bottom := BH;
  end;
 paintbox2.Canvas.CopyRect(rd,map2.Canvas,rs);
end;

end.


